#include<string>
using namespace std;

#ifndef ZAIDEJAS_H
#define ZAIDEJAS_H

class zaidejas
{
	string vardas;
	int patirtis;
public:
	zaidejas(const string& name, const int patyres) : vardas(name), patirtis(patyres) {}
	virtual string get_vardas() const {return vardas;}
	virtual int get_patirtis() const {return patirtis;}
	virtual string get_tipas() const = 0;
	virtual int get_gynyba() const = 0;
	virtual int get_ataka() const = 0;
	virtual int get_aikste() const = 0;
	virtual int verte() const = 0;
};

//---templatas
template<class T, int size = 100 >
class Tipas
{
  T reiksme[size];
  int top;
public:
	Tipas(): top(0) {}
	void setr(const T& i) { reiksme[top++] = i; }
	T getr() { return reiksme[--top]; }
  
class iterator; // Declaration required
friend class iterator; // Make it a friend
class iterator { // Now define it
	Tipas& s;
	int index;
public:
	iterator(Tipas& st): s(st), index(0){}
	// To create the "end sentinel" iterator:
	iterator(Tipas& st, bool): s(st), index(s.top) {}
	T operator*() const { return s.reiksme[index]; }
	T operator++() { return s.reiksme[++index]; }
	T operator++(int) { return s.reiksme[index++]; }
	// Jump an iterator forward
	iterator& operator+=(int amount) {index += amount; return *this; }
	// To see if you're at the end:
	bool operator==(const iterator& rv) const { return index == rv.index; }
	bool operator!=(const iterator& rv) const { return index != rv.index; }

	friend std::ostream& operator<<(
	std::ostream& os, const iterator& it) { return os << *it; }
};
  
  iterator begin() { return iterator(*this); }
  // Create the "end sentinel":
  iterator end() { return iterator(*this, true);}
};


#endif
