#include <iostream>
using namespace std;
#include "komanda.h"

void komanda :: ideti_zaideja()
{
	string tempp;
	int temppp;
	cout << "Iveskite zaidejo varda: ";
	cin >> tempp;

	cout <<"Pasirinkite zaidejo tipa:" << endl;
	cout << "1-gynejas" << endl;
	cout << "2-saugas" << endl;
	cout << "3-puolejas" << endl;
	cin >> temppp;
	if (temppp<0 || temppp>3) throw string("Tokio tipo nera!");

	zaidejas *temp;
	switch(temppp)
	{
	case 1 : temp = new gynejas(tempp,3); break;
	case 2 : temp = new saugas(tempp,3); break;
	case 3 : temp = new puolejas(tempp,3); break;
	default: throw string("Tokio pasirinkimo nera!");
	}
	komand.push_back(temp);
}

void komanda :: kopijuoti_zaideja()
{
	if (komand.size() == 0) cout << "Zaideju nera!" << endl;
	else
	{
		int temp;
		cout << "Pasirinkite pagal kuri zaideja kopijuosite:" << endl;

		rodyti_zaidejus();
		cin >> temp;
		if (temp<0 || temp>komand.size()) throw string("Tokio zaidejo nera!");
		
		vector<zaidejas*>::iterator it = komand.begin();
		for(int i = 1; i < temp; i++) it++;

		zaidejas *temmp; 
		//--kopijavimo konstruktorius
		if ((*it)->get_tipas() == "Gynejas") temmp = new gynejas(*(*it));
		if ((*it)->get_tipas() == "Saugas")  temmp = new saugas(*(*it));
		if ((*it)->get_tipas() == "Puolejas") temmp = new puolejas(*(*it));

		komand.push_back(temmp);
	}
}

void komanda :: paziureti_zaideja()
{
	int zaid, i=0;
	if (komand.size() == 0) cout << "Zaideju nera!" << endl;
	else
	{
	cout << "*** ZAIDEJO STATISTIKA ***" << endl;
	cout << "Pasirinkite zaideja nuo 1 iki " << komand.size() << "  (0-atsaukti)" << endl;
	vector<zaidejas*>::iterator it = komand.begin();

	rodyti_zaidejus();

	cin >> zaid;
	if (zaid<0 || zaid>komand.size()) throw string("Tokio zaidejo nera!");

	it = komand.begin();
	for(i = 1; i < zaid; i++) it++;
	if (zaid != 0)
	{
	cout << "--------------------------------------------" << endl;
	cout << "|Zaidejo vardas = " << (*it)->get_vardas() <<endl;
	cout << "|tipas = " << (*it)->get_tipas() <<endl;
	cout << "|patirtis = " << (*it)->get_patirtis() <<endl;
	cout << "|ginyba = " << (*it)->get_gynyba() <<endl;
	cout << "|ataka = " << (*it)->get_ataka() <<endl;
	cout << "|aikste = " << (*it)->get_aikste() <<endl;
	cout << "|verte = " << (*it)->verte() <<endl;
	cout << "--------------------------------------------" << endl;
	}
	}
}

void komanda :: paziureti_komanda()
{
	int all_g=0, all_s=0, all_p=0;
	int all_pat=0, all_gyn=0, all_ata=0, all_aik=0, all_ver=0;
	
	cout << "*** KOMANDOS STATISTIKA ***" <<endl;
	for(vector<zaidejas*>::iterator it =
	komand.begin();
	it != komand.end(); ++it)
	{
		if("Gynejas" == (*it)->get_tipas()) all_g++;
		if("Saugas" == (*it)->get_tipas()) all_s++;
		if("Puolejas" == (*it)->get_tipas()) all_p++;
		all_pat = all_pat + (*it)->get_patirtis();
		all_gyn = all_gyn + (*it)->get_gynyba();
		all_ata = all_ata + (*it)->get_ataka();
		all_aik = all_aik + (*it)->get_aikste();
		all_ver = all_ver + (*it)->verte();
	}
	
	cout << "--------------------------------------------" << endl;
	cout << "|gyneju-" << all_g << "  saugu-" << all_s << "  puoleju-" << all_p <<endl;
	cout << "|bendra patirtis = " << all_pat <<endl;
	cout << "|bendra ginyba = " << all_gyn <<endl;
	cout << "|bendra ataka = " << all_ata <<endl;
	cout << "|bendra aikste = " << all_aik <<endl;
	cout << "|bendra verte = " << all_ver <<endl;
	cout << "--------------------------------------------" << endl;

}

void komanda :: istrinti_zaideja()
{

	int kuris;
	if (komand.size() == 0) cout << "Zaideju nera!" << endl;
	else
	{
	cout << "Pasirinkite zaideja nuo 1 iki " << komand.size() << "  (0-atsaukti)" << endl;
	vector<zaidejas*>::iterator it	= komand.begin();
	
	rodyti_zaidejus();
	cin >> kuris;
	if (kuris<0 || kuris>komand.size()) throw string("Tokio zaidejo nera!");

	for(int i = 1; i < kuris; i++) it++;
	if(kuris)
	{
	komand.erase(it); cout << "Zaidejas istrintas." << endl;
	}
	}
}

void komanda :: rodyti_zaidejus()
{
	int i = 0;
	vector<zaidejas*>::iterator it = komand.begin();
	do
	{
	cout << ++i << "  " << (*it)->get_vardas() << "  " << (*it)->get_tipas() <<  endl;
	it++;	
	}while(it != komand.end());
}
